////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"


#include <setup.h>
#include <stringhelpers.h>
#include <tools.h>
#include <users.h>
#include <live.h>
#include <livefeatures.h>

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "h\001\000\000\326\001\000\000\343\001\000\000\350\001\000\000\255\005\000\000\262\005\000"
  "\0002\006\000\000z\006\000\000F\007\000\000\273\007\000\0004\010\000\0001\t\000\000y\t\000\000\017\n\000\000[\n\000"
  "\000\021\013\000\000\216\013\000\000\373\013\000\000J\014\000\000q\014\000\000\330\014\000\000+\015\000\000F\015\000"
  "\000V\015\000\000\275\015\000\000\024\016\000\000\306\016\000\000A\017\000\000\263\017\000\0004\020\000\000Y\020\000"
  "\000\246\020\000\000)\021\000\000\307\021\000\000;\022\000\000\256\022\000\000\?\023\000\000r\023\000\000\245\023\000"
  "\000\327\023\000\000\n\024\000\000K\024\000\000\332\024\000\000\247\025\000\000[\026\000\000\326\026\000\000H\027\000"
  "\000\255\027\000\000%\030\000\000z\030\000\000\230\030\000\000\373\030\000\000\246\031\000\000\010\032\000\000\230"
  "\032\000\000\366\032\000\000\210\033\000\000\347\033\000\000\205\034\000\000\352\034\000\000\365\035\000\000E\036\000"
  "\000m\036\000\000\037\037\000\000\223\037\000\000\037 \000\000\266 \000\000)!\000\000\266!\000\000\267!\000\000\353!"
  "\000\000\354!\000\000\035\"\000\000\036\"\000\000T\"\000\000U\"\000\000\210\"\000\000\211\"\000\000\270\"\000\000\271"
  "\"\000\000;#\000\000\223#\000\000\260#\000\000\262#\000\000\263#\000\000\275#\000\000\251$\000\000'%\000\000(%\000"
  "\000)%\000\000\n<html>\n  <head>\n<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <ti"
  "tle>VDR-Live - </title>\n    \n    \n    <script type=\"text/javascript\"><!--\n    function initform()\n    {\n     "
  " changeduseauth(document.getElementById(\"useauth\"));\n      changedChanGroups();\n      if (document.getElementById"
  "(\"message\").value != \"\")\n        alert(document.getElementById(\"message\").value);\n    }\n    function changed"
  "useauth(selection)\n    {\n      document.getElementById(\"authsection\").style.display = (selection.checked \? \"blo"
  "ck\" : \"none\");\n    }\n    function setauthchanged(selection)\n    {\n      document.getElementById(\"authchanged"
  "\").value = 1;\n    }\n    function changedChanGroups() {\n      if (document.getElementById(\"channelGroupsGen_indiv"
  "idual\").checked) {\n         document.getElementById(\"individual_channelGroups_section\").style.display = \"block\""
  "\n      } else {\n         document.getElementById(\"individual_channelGroups_section\").style.display = \"none\"\n  "
  "    }\n    }\n    //--></script>\n  </head>\n  <body onload=\"initform(); adjustHeader()\" onresize=\"adjustHeader()"
  "\">\n    \n    \n    <div class=\"inhalt\">\n      <form method=\"post\" action=\"setup.html\">\n        <input type="
  "\"hidden\" name=\"authchanged\" value=\"\" id=\"authchanged\"/>\n        <input type=\"hidden\" name=\"message\" valu"
  "e=\"\" id=\"message\"/>\n        <table class=\"formular\" cellpadding=\"0\" cellspacing=\"0\">\n          <tr class="
  "\"head\">\n            <td  class=\"toprow leftcol rightcol\" colspan=\"2\"><div class=\"boxheader\"><div><div></div>"
  "</div></div></td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\""
  ">:</div></td>\n            <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"useauth\" id=\"usea"
  "uth\" value=\"1\" onclick=\"changeduseauth(this)\"/>\n              <div id=\"authsection\" style=\"display: none\">"
  "\n              <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n              <tr>\n   "
  "             <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"text\" nam"
  "e=\"login\" value=\"\" id=\"login\" onchange=\"setauthchanged(this)\" /></td>\n              </tr>\n              <tr"
  ">\n                <td class=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input  type=\"pas"
  "sword\" name=\"pass\" value=\"\" id=\"pass\" onchange=\"setauthchanged(this)\" /></td>\n              </tr>\n        "
  "      <tr>\n                <td colspan=\"2\" class=\"label\"><div class=\"withmargin\"><a href=\"users.html\"></a></"
  "div></td>\n              </tr>\n              <tr>\n                <td colspan=\"2\" class=\"label\"><div class=\"wi"
  "thmargin\"></div></td>\n              </tr>\n              <tr>\n                <td class=\"label\"><div class=\"wit"
  "hmargin\">:</div></td>\n                <td><input type=\"text\" name=\"localnetmask\" value=\"\" id=\"localnetmask\""
  " />\n                </td>\n              </tr>\n              <tr>\n                <td class=\"label\"><div class="
  "\"withmargin\">:</div></td>\n                <td><input type=\"text\" name=\"localnetmaskIPv6\" value=\"\" id=\"local"
  "netmaskIPv6\" />\n                </td>\n              </tr>\n              <tr>\n                <td class=\"label\""
  "><div class=\"withmargin\">:</div></td>\n                <td><input type=\"checkbox\" name=\"allowlocalhost\" value="
  "\"1\"/>\n              </tr>\n              </table>\n              </div>\n            </td>\n          </tr>\n     "
  "     <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"ri"
  "ghtcol\">\n              <input type=\"checkbox\" name=\"showLogo\" id=\"showLogo\" value=\"1\"/>\n            </td>"
  "\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n  "
  "          <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"showInfoBox\" id=\"showInfoBox\" val"
  "ue=\"1\"/>\n            </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\""
  "withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <input type=\"checkbox\" name=\"useStre"
  "amdev\" id=\"useStreamdev\" value=\"1\" onclick=\"changedusestreamdev(this)\"/>\n            </td>\n          </tr>\n"
  "              <tr>\n                <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n             "
  "   <td class=\"rightcol\"><input type=\"text\" name=\"streamdevport\" id=\"streamdevport\" value=\"\" /></td>\n      "
  "        </tr>\n              <tr>\n                <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>"
  "\n                <td class=\"rightcol\"><select name=\"streamdevtype\" size=\"1\" id=\"streamdevtype\">\n           "
  "       <option value=\"TS\" >TS</option>\n                  <option value=\"PES\" >PES</option>\n                  <o"
  "ption value=\"PS\" >PS</option>\n                  <option value=\"ES\" >ES</option>\n                  <option value"
  "=\"EXT\" >EXT</option>\n                </select></td>\n              </tr>\n                                        "
  "<tr>\n                                                <td class=\"label leftcol\"><div class=\"withmargin\">:</div></"
  "td>\n                                                <td class=\"rightcol\">\n                                       "
  "                 <input type=\"checkbox\" name=\"markNewRec\" id=\"markNewRec\" value=\"1\"/>\n                      "
  "                          </td>\n                                        </tr>\n          <tr>\n            <td class"
  "=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n              <input "
  "type=\"checkbox\" name=\"showIMDb\" id=\"showIMDb\" value=\"1\"/>\n            </td>\n          </tr>\n          <tr>"
  "\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">"
  "<input type=\"number\" min=\"0\" name=\"lastchannel\" value=\"\" id=\"lastchannel\" /></td>\n          </tr>\n       "
  "   <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"righ"
  "tcol\"><input type=\"text\" name=\"times\" value=\"\" id=\"times\" />\n              </td>\n          </tr>\n        "
  "  <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"right"
  "col\">\n            <div class=\"dotted\">\n              <input id=\"channelGroupsGen_default\" name=\"channelGroups"
  "Gen\" value=\"default\"  type=\"radio\" onclick=\"changedChanGroups()\"/>\n              <label for=\"channelGroupsGe"
  "n_default\"></label>\n            </div>\n            <div class=\"dotted\">\n              <input id=\"channelGroups"
  "Gen_vdr\" name=\"channelGroupsGen\" value=\"vdr\"  type=\"radio\" onclick=\"changedChanGroups()\"/>\n              <l"
  "abel for=\"channelGroupsGen_vdr\"></label>\n            </div>\n            <div class=\"dotted\">\n              <in"
  "put id=\"channelGroupsGen_flat\" name=\"channelGroupsGen\" value=\"flat\"  type=\"radio\" onclick=\"changedChanGroups"
  "()\"/>\n              <label for=\"channelGroupsGen_flat\"></label>\n            </div>\n            <div class=\"dot"
  "ted\">\n              <input id=\"channelGroupsGen_individual\" name=\"channelGroupsGen\" value=\"individual\"  type="
  "\"radio\" onclick=\"changedChanGroups()\"/>\n              <label for=\"channelGroupsGen_individual\"></label>\n     "
  "       </div>\n\n            <div id=\"individual_channelGroups_section\" style=\"display: none\">\n              <ta"
  "ble border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n              <tr>\n                <td cl"
  "ass=\"label\"><div class=\"withmargin\">:</div></td>\n                <td><input type=\"text\" name=\"channelGroups\""
  " value=\"\" id=\"channelGroups\" />\n                </td>\n              </tr>\n              </table>\n            "
  "</div>\n\n          </td>\n          </tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"with"
  "margin\">:</div></td>\n            <td class=\"rightcol\"><input type=\"number\" min=\"1\" max= \"23\" name=\"schedul"
  "eDuration\" value=\"\" id=\"scheduleDuration\" />\n              </td>\n          </tr>\n          <tr>\n            "
  "<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td class=\"rightcol\">\n            "
  "  <input type=\"checkbox\" name=\"showChannelsWithoutEPG\" id=\"showChannelsWithoutEPG\" value=\"1\"/>\n            <"
  "/td>\n          </tr>\n\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></t"
  "d>\n            <td class=\"rightcol\"><select name=\"startscreen\" size=\"1\" id=\"startscreen\">\n              <op"
  "tion value=\"whatsonnow\" ></option>\n              <option value=\"whatsonnext\" ></option>\n              <option v"
  "alue=\"schedule\" ></option>\n              <option value=\"multischedule\" ></option>\n              <option value="
  "\"recordings\" ></option>\n              <option value=\"timers\" ></option>\n            </select></td>\n          <"
  "/tr>\n          <tr>\n            <td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n            <td"
  " class=\"rightcol\"><select name=\"theme\" size=\"1\" id=\"theme\">\n              <option value=\"\" ></option>\n   "
  "         </select></td>\n          </tr>\n          <tr>\n            <td class=\"buttonpanel leftcol rightcol bottom"
  "row\" colspan=\"2\">\n              <div class=\"withmargin\">\n              <button class=\"green\" type=\"submit\""
  " name=\"save\" ></button>\n              </div>\n            </td>\n          </tr>\n        </table>\n      </form>"
  "\n    </div>\n  </body>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string lastchannel = qparam.get< std::string >("lastchannel");
bool useauth = qparam.get< bool >("useauth", ( false));
std::string login = qparam.get< std::string >("login");
std::string pass = qparam.get< std::string >("pass");
std::string times = qparam.get< std::string >("times");
std::string channelGroupsGen = qparam.get< std::string >("channelGroupsGen");
std::string channelGroups = qparam.get< std::string >("channelGroups");
std::string scheduleDuration = qparam.get< std::string >("scheduleDuration");
std::string startscreen = qparam.get< std::string >("startscreen");
std::string theme = qparam.get< std::string >("theme");
std::string localnetmask = qparam.get< std::string >("localnetmask");
std::string localnetmaskIPv6 = qparam.get< std::string >("localnetmaskIPv6");
std::string allowlocalhost = qparam.get< std::string >("allowlocalhost");
std::string showLogo = qparam.get< std::string >("showLogo");
std::string showInfoBox = qparam.get< std::string >("showInfoBox");
std::string useStreamdev = qparam.get< std::string >("useStreamdev");
std::string markNewRec = qparam.get< std::string >("markNewRec");
std::string showIMDb = qparam.get< std::string >("showIMDb");
std::string showChannelsWithoutEPG = qparam.get< std::string >("showChannelsWithoutEPG");
std::string streamdevport = qparam.get< std::string >("streamdevport");
std::string streamdevtype = qparam.get< std::string >("streamdevtype");
int authchanged = qparam.get< int >("authchanged", ( 0));
  // </%args>

#line 38 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 41 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}
if (!cUser::CurrentUserHasRightTo(UR_EDITSETUP))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? " checked=\"checked\"" : "" );

  std::string message;

  if ( request.getMethod() == "POST") {
    if (authchanged && useauth && (login.empty() || pass.empty()))
      message = tr("Please set login and password!");
    else
    {
      LiveSetup().SetLastChannel(lastchannel != "" ? parse_int<int>(lastchannel):0);
      LiveSetup().SetUseAuth(useauth);
      if (useauth) {
        LiveSetup().SetAdminLogin(login);
        if (pass != "")
          LiveSetup().SetAdminPassword(pass);
        LiveSetup().SetLocalNetMask(localnetmask);
        LiveSetup().SetLocalNetMaskIPv6(localnetmaskIPv6);
        LiveSetup().SetAllowLocalhost(!allowlocalhost.empty());
        LiveSetup().CheckLocalNet(request.getPeerIp());
      }
      LiveSetup().SetTimes(times);
// for multischedule
      LiveSetup().SetChannelGroupsGen(channelGroupsGen);
      LiveSetup().SetChannelGroups(channelGroups);
      LiveSetup().SetScheduleDuration(scheduleDuration);
// end multischedule
      LiveSetup().SetStartScreen(startscreen);
      LiveSetup().SetTheme(theme);
      LiveSetup().SetShowLogo(!showLogo.empty());
      LiveSetup().SetShowInfoBox(!showInfoBox.empty());
      LiveSetup().SetUseStreamdev(!useStreamdev.empty());
      LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : parse_int<int>(streamdevport));
      LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
      LiveSetup().SetMarkNewRec(!markNewRec.empty());

      LiveSetup().SetShowIMDb(!showIMDb.empty());
      LiveSetup().SetShowChannelsWithoutEPG(!showChannelsWithoutEPG.empty());
      LiveSetup().SaveSetup();

      message = tr("Setup saved.");
    }
  }
  pageTitle = tr("Setup");
  int ilastchannel = LiveSetup().GetLastChannel();
  if (ilastchannel == std::numeric_limits< int >::max())
    lastchannel = "";
  else
    lastchannel = std::string(cToSvInt(ilastchannel));

  login = LiveSetup().GetAdminLogin();
  useauth = LiveSetup().GetUseAuth();
  times = LiveSetup().GetTimes();
  channelGroups = LiveSetup().GetChannelGroups();
  channelGroupsGen = LiveSetup().GetChannelGroupsGen();
  scheduleDuration = LiveSetup().GetScheduleDuration();
  startscreen = LiveSetup().GetStartScreen();
  theme = LiveSetup().GetTheme();
  localnetmask = LiveSetup().GetLocalNetMask();
  localnetmaskIPv6 = LiveSetup().GetLocalNetMaskIPv6();
  allowlocalhost = LiveSetup().GetAllowLocalhost() ? "1" : "";
  showLogo = LiveSetup().GetShowLogo() ? "1" : "";
  showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
  useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
  streamdevport = std::string(cToSvInt(LiveSetup().GetStreamdevPort()));
  streamdevtype = LiveSetup().GetStreamdevType();
  markNewRec = LiveSetup().GetMarkNewRec() ? "1" : "";
  showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";
  showChannelsWithoutEPG = LiveSetup().GetShowChannelsWithoutEPG() ? "1" : "";

  // <& pageelems.doc_type ...
  { 
#line 120 "setup.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 120 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n<html>\n  <head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 124 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[1]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 125 "setup.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 125 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 126 "setup.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 126 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n    <script type="text/javascript"><!--\n    function initform()\n    {\n      changeduseauth(document.getElementById("useauth"));\n      changedChanGroups();\n      if (document.getElementById("message").value != "")\n        alert(document.getElementById("message").value);\n    }\n    function changeduseauth(selection)\n    {\n      document.getElementById("authsection").style.display = (selection.checked \? "block" : "none");\n    }\n    function setauthchanged(selection)\n    {\n      document.getElementById("authchanged").value = 1;\n    }\n    function changedChanGroups() {\n      if (document.getElementById("channelGroupsGen_individual").checked) {\n         document.getElementById("individual_channelGroups_section").style.display = "block"\n      } else {\n         document.getElementById("individual_channelGroups_section").style.display = "none"\n      }\n    }\n    //--></script>\n  </head>\n  <body onload="initform(); adjustHeader()" onresize="adjustHeader()">\n    
  // <& pageelems.logo ...
  { 
#line 153 "setup.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 153 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n    
  // <& menu ...
  { 
#line 154 "setup.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 154 "setup.ecpp"
    _tnt_cq4.add( "active", ("setup"));
#line 154 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    <div class="inhalt">\n      <form method="post" action="setup.html">\n        <input type="hidden" name="authchanged" value="
#line 157 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << _tntChunks[6]; // " id="authchanged"/>\n        <input type="hidden" name="message" value="
#line 158 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << _tntChunks[7]; // " id="message"/>\n        <table class="formular" cellpadding="0" cellspacing="0">\n          <tr class="head">\n            <td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div>
#line 161 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << _tntChunks[8]; // </div></div></div></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 164 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << _tntChunks[9]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="useauth" id="useauth" value="1"
#line 166 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << _tntChunks[10]; //  onclick="changeduseauth(this)"/>\n              <div id="authsection" style="display: none">\n              <table border="0" cellpadding="0" cellspacing="0" class="dependent">\n              <tr>\n                <td class="label"><div class="withmargin">
#line 170 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << _tntChunks[11]; // :</div></td>\n                <td><input type="text" name="login" value="
#line 171 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << _tntChunks[12]; // " id="login" onchange="setauthchanged(this)" /></td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 174 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << _tntChunks[13]; // :</div></td>\n                <td><input  type="password" name="pass" value="
#line 175 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << _tntChunks[14]; // " id="pass" onchange="setauthchanged(this)" /></td>\n              </tr>\n              <tr>\n                <td colspan="2" class="label"><div class="withmargin"><a href="users.html">
#line 178 "setup.ecpp"
  reply.sout() << ( tr("User management") );
  reply.out() << _tntChunks[15]; // </a></div></td>\n              </tr>\n              <tr>\n                <td colspan="2" class="label"><div class="withmargin">
#line 181 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << _tntChunks[16]; // </div></td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 184 "setup.ecpp"
  reply.sout() << ( tr("IPv4 prefix") );
  reply.out() << _tntChunks[17]; // :</div></td>\n                <td><input type="text" name="localnetmask" value="
#line 185 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << _tntChunks[18]; // " id="localnetmask" />\n                
  // <& tooltip.help ...
  { 
#line 186 "setup.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 186 "setup.ecpp"
    _tnt_cq5.add( "text", (tr("Example: 192.168.178.0/24")));
#line 186 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[19]; // </td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 189 "setup.ecpp"
  reply.sout() << ( tr("IPv6 prefix") );
  reply.out() << _tntChunks[20]; // :</div></td>\n                <td><input type="text" name="localnetmaskIPv6" value="
#line 190 "setup.ecpp"
  reply.sout() << ( localnetmaskIPv6 );
  reply.out() << _tntChunks[21]; // " id="localnetmaskIPv6" />\n
#line 191 "setup.ecpp"
               // the mootools unfortunately use "::" as separator for title and text,

#line 192 "setup.ecpp"
               // so we need to escape this by inserting an invisible space U+200B in-between

  reply.out() << _tntChunks[22]; //                 
  // <& tooltip.help ...
  { 
#line 193 "setup.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 193 "setup.ecpp"
    _tnt_cq6.add( "text", (tr("Example: 2003:ec:6f23:ee00:&#x200B;:/64")));
#line 193 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[23]; // </td>\n              </tr>\n              <tr>\n                <td class="label"><div class="withmargin">
#line 196 "setup.ecpp"
  reply.sout() << ( tr("Allow localhost") );
  reply.out() << _tntChunks[24]; // :</div></td>\n                <td><input type="checkbox" name="allowlocalhost" value="1"
#line 197 "setup.ecpp"
 CHECKIF(!allowlocalhost.empty()); 
  reply.out() << _tntChunks[25]; // />\n              </tr>\n              </table>\n              </div>\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 204 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << _tntChunks[26]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showLogo" id="showLogo" value="1"
#line 206 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << _tntChunks[27]; // />\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 210 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << _tntChunks[28]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showInfoBox" id="showInfoBox" value="1"
#line 212 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << _tntChunks[29]; // />\n            </td>\n          </tr>\n
#line 215 "setup.ecpp"
 if (LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[30]; //           <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 217 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << _tntChunks[31]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="useStreamdev" id="useStreamdev" value="1"
#line 219 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << _tntChunks[32]; //  onclick="changedusestreamdev(this)"/>\n            </td>\n          </tr>\n              <tr>\n                <td class="label leftcol"><div class="withmargin">
#line 223 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << _tntChunks[33]; // :</div></td>\n                <td class="rightcol"><input type="text" name="streamdevport" id="streamdevport" value="
#line 224 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << _tntChunks[34]; // " /></td>\n              </tr>\n              <tr>\n                <td class="label leftcol"><div class="withmargin">
#line 227 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << _tntChunks[35]; // :</div></td>\n                <td class="rightcol"><select name="streamdevtype" size="1" id="streamdevtype">\n                  <option value="TS" 
#line 229 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << _tntChunks[36]; // >TS</option>\n                  <option value="PES" 
#line 230 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << _tntChunks[37]; // >PES</option>\n                  <option value="PS" 
#line 231 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << _tntChunks[38]; // >PS</option>\n                  <option value="ES" 
#line 232 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << _tntChunks[39]; // >ES</option>\n                  <option value="EXT" 
#line 233 "setup.ecpp"
 SELECTIF(streamdevtype == "EXT") 
  reply.out() << _tntChunks[40]; // >EXT</option>\n                </select></td>\n              </tr>\n
#line 236 "setup.ecpp"
 }   // endif LiveFeatures<features::streamdev_server>().Loaded()

  reply.out() << _tntChunks[41]; //                                         <tr>\n                                                <td class="label leftcol"><div class="withmargin">
#line 238 "setup.ecpp"
  reply.sout() << ( tr("Mark new recordings") );
  reply.out() << _tntChunks[42]; // :</div></td>\n                                                <td class="rightcol">\n                                                        <input type="checkbox" name="markNewRec" id="markNewRec" value="1"
#line 240 "setup.ecpp"
 CHECKIF(!markNewRec.empty()); 
  reply.out() << _tntChunks[43]; // />\n                                                </td>\n                                        </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 244 "setup.ecpp"
  reply.sout() << ( tr("Show link to IMDb in list views") );
  reply.out() << _tntChunks[44]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showIMDb" id="showIMDb" value="1"
#line 246 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << _tntChunks[45]; // />\n            </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 250 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << _tntChunks[46]; // :</div></td>\n            <td class="rightcol"><input type="number" min="0" name="lastchannel" value="
#line 251 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << _tntChunks[47]; // " id="lastchannel" /></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 254 "setup.ecpp"
  reply.sout() << ( tr("Additional fixed times in 'What's on?'") );
  reply.out() << _tntChunks[48]; // :</div></td>\n            <td class="rightcol"><input type="text" name="times" value="
#line 255 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << _tntChunks[49]; // " id="times" />\n              
  // <& tooltip.help ...
  { 
#line 256 "setup.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 256 "setup.ecpp"
    _tnt_cq7.add( "text", (tr("Format is HH:MM. Separate multiple times with a semicolon")));
#line 256 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[50]; // </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 259 "setup.ecpp"
  reply.sout() << ( tr("Channel groups for MultiSchedule") );
  reply.out() << _tntChunks[51]; // :</div></td>\n            <td class="rightcol">\n            <div class="dotted">\n              <input id="channelGroupsGen_default" name="channelGroupsGen" value="default" 
#line 262 "setup.ecpp"
  if ( channelGroupsGen=="default"||channelGroupsGen.empty() )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[52]; //  type="radio" onclick="changedChanGroups()"/>\n              <label for="channelGroupsGen_default">
#line 263 "setup.ecpp"
  reply.sout() << ( tr("5 channels per group") );
  reply.out() << _tntChunks[53]; // </label>\n            </div>\n            <div class="dotted">\n              <input id="channelGroupsGen_vdr" name="channelGroupsGen" value="vdr" 
#line 266 "setup.ecpp"
  if ( channelGroupsGen=="vdr" )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[54]; //  type="radio" onclick="changedChanGroups()"/>\n              <label for="channelGroupsGen_vdr">
#line 267 "setup.ecpp"
  reply.sout() << ( tr("Channel groups as defined in VDR") );
  reply.out() << _tntChunks[55]; // </label>\n            </div>\n            <div class="dotted">\n              <input id="channelGroupsGen_flat" name="channelGroupsGen" value="flat" 
#line 270 "setup.ecpp"
  if ( channelGroupsGen=="flat" )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[56]; //  type="radio" onclick="changedChanGroups()"/>\n              <label for="channelGroupsGen_flat">
#line 271 "setup.ecpp"
  reply.sout() << ( tr("All channels in one group") );
  reply.out() << _tntChunks[57]; // </label>\n            </div>\n            <div class="dotted">\n              <input id="channelGroupsGen_individual" name="channelGroupsGen" value="individual" 
#line 274 "setup.ecpp"
  if ( channelGroupsGen=="individual" )
    reply.out() <<  "checked=\"checked\"" ;
  reply.out() << _tntChunks[58]; //  type="radio" onclick="changedChanGroups()"/>\n              <label for="channelGroupsGen_individual">
#line 275 "setup.ecpp"
  reply.sout() << ( tr("Individual channel groups") );
  reply.out() << _tntChunks[59]; // </label>\n            </div>\n\n            <div id="individual_channelGroups_section" style="display: none">\n              <table border="0" cellpadding="0" cellspacing="0" class="dependent">\n              <tr>\n                <td class="label"><div class="withmargin">
#line 281 "setup.ecpp"
  reply.sout() << ( tr("Channel groups") );
  reply.out() << _tntChunks[60]; // :</div></td>\n                <td><input type="text" name="channelGroups" value="
#line 282 "setup.ecpp"
  reply.sout() << ( channelGroups );
  reply.out() << _tntChunks[61]; // " id="channelGroups" />\n                
  // <& tooltip.help ...
  { 
#line 283 "setup.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 283 "setup.ecpp"
    _tnt_cq8.add( "text", (tr("Separate channels with a comma ',', separate groups with a semi-colon ';'")));
#line 283 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[62]; // </td>\n              </tr>\n              </table>\n            </div>\n\n          </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 291 "setup.ecpp"
  reply.sout() << ( tr("Duration of MultiSchedule in hours") );
  reply.out() << _tntChunks[63]; // :</div></td>\n            <td class="rightcol"><input type="number" min="1" max= "23" name="scheduleDuration" value="
#line 292 "setup.ecpp"
  reply.sout() << ( scheduleDuration );
  reply.out() << _tntChunks[64]; // " id="scheduleDuration" />\n              </td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 296 "setup.ecpp"
  reply.sout() << ( tr("Show channels without EPG") );
  reply.out() << _tntChunks[65]; // :</div></td>\n            <td class="rightcol">\n              <input type="checkbox" name="showChannelsWithoutEPG" id="showChannelsWithoutEPG" value="1"
#line 298 "setup.ecpp"
 CHECKIF(!showChannelsWithoutEPG.empty()); 
  reply.out() << _tntChunks[66]; // />\n            </td>\n          </tr>\n\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 303 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << _tntChunks[67]; // :</div></td>\n            <td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n              <option value="whatsonnow" 
#line 305 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << _tntChunks[68]; // >
#line 305 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << _tntChunks[69]; // </option>\n              <option value="whatsonnext" 
#line 306 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << _tntChunks[70]; // >
#line 306 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << _tntChunks[71]; // </option>\n              <option value="schedule" 
#line 307 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << _tntChunks[72]; // >
#line 307 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << _tntChunks[73]; // </option>\n              <option value="multischedule" 
#line 308 "setup.ecpp"
 SELECTIF(startscreen == "multischedule") 
  reply.out() << _tntChunks[74]; // >
#line 308 "setup.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << _tntChunks[75]; // </option>\n              <option value="recordings" 
#line 309 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << _tntChunks[76]; // >
#line 309 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << _tntChunks[77]; // </option>\n              <option value="timers" 
#line 310 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << _tntChunks[78]; // >
#line 310 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << _tntChunks[79]; // </option>\n            </select></td>\n          </tr>\n          <tr>\n            <td class="label leftcol"><div class="withmargin">
#line 314 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << _tntChunks[80]; // :</div></td>\n            <td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 316 "setup.ecpp"

{
  const std::string dirPath(Plugin::GetResourceDirectory() + "/themes");
  cReadDir d(dirPath.c_str());
  struct dirent* e;
  std::string parent("..");
  std::string current(".");
  std::string cvsDir("CVS");
  while ((e = d.Next())) {
    if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
      continue;
    }
    /* Check if entry is a directory: I do not rely on e->d_type
       here because on some systems it is allways DT_UNKNOWN. Also
       testing for DT_DIR does not take into account symbolic
       links to directories.
    */
    struct stat buf;
    if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
      continue;
    }

  reply.out() << _tntChunks[81]; //               <option value="
#line 338 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[82]; // " 
#line 338 "setup.ecpp"
 SELECTIF(theme == e->d_name) 
  reply.out() << _tntChunks[83]; // >
#line 338 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << _tntChunks[84]; // </option>\n
#line 339 "setup.ecpp"

  }
}

  reply.out() << _tntChunks[85]; //             </select></td>\n          </tr>\n          <tr>\n            <td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n              <div class="withmargin">\n              <button class="green" type="submit" name="save" >
#line 348 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << _tntChunks[86]; // </button>\n              </div>\n            </td>\n          </tr>\n        </table>\n      </form>\n    </div>\n  </body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[87]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[88]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
